
let ht = Hashtbl.create 10;;

Hashtbl.add ht "foo" "bar";;

if Hashtbl.mem ht "foo" then
  Printf.printf "hashtable has foo!\n"
else
  Printf.printf "no foo in hashtable\n";;

Hashtbl.replace ht "foo" "baz";;

try
   let x = Hashtbl.find ht "foo" in
      Printf.printf "foo : %s\n" x
with Not_found ->
    Printf.printf "no foo in Hashtbl.find\n";;

try
   let x = Hashtbl.find ht "bar" in
      Printf.printf "bar : %s\n" x
with Not_found ->
    Printf.printf "no bar in Hashtbl.find\n";;

Printf.printf "First iteration:\n";;
Hashtbl.iter (fun x y -> Printf.printf "%s: %s\n" x y) ht;;

Hashtbl.add ht "foo" "bar2";;

Printf.printf "Second iteration:\n";;
Hashtbl.iter (fun x y -> Printf.printf "%s: %s\n" x y) ht;;
